/*
 *   $Id: datatypes.h,v 1.3 2025/03/09 19:14:24 snw Exp $
 *    FreeM data types
 *
 *  
 *   Author: Serena Willis <snw@coherent-logic.com>
 *    Copyright (C) 1998 MUG Deutschland
 *    Copyright (C) 2023, 2025 Coherent Logic Development LLC
 *
 *
 *   This file is part of FreeM.
 *
 *   FreeM is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   FreeM is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Affero Public License for more details.
 *
 *   You should have received a copy of the GNU Affero Public License
 *   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
 *
 *   $Log: datatypes.h,v $
 *   Revision 1.3  2025/03/09 19:14:24  snw
 *   First phase of REUSE compliance and header reformat
 *
 *
 * SPDX-FileCopyrightText:  (C) 2025 Coherent Logic Development LLC
 * SPDX-License-Identifier: AGPL-3.0-or-later 
 **/

#if !defined(__DATATYPES_H__)
# define __DATATYPES_H__

#define DT_AUTO 0
#define DT_BOOLEAN 1
#define DT_COMPLEX 2
#define DT_INTEGER 3
#define DT_MATRIX 4
#define DT_NAME 5
#define DT_REAL 6
#define DT_STRING 7
#define DT_INVALID 100

extern short dt_get_type(char *type_string);
extern short dt_check(short datatype, char *data, int arg_num);
extern short dt_check_complex(char *data);
extern short dt_check_integer(char *data);
extern short dt_check_matrix(char *data);
extern short dt_check_name(char *data);
extern short dt_check_real(char *data);

#endif
